%define anolis_release 3

Name:           udisks2
Version:        2.9.4
Release:        %{anolis_release}%{?dist}
Summary:        Disk Manager

License:        GPLv2+
URL:            https://github.com/storaged-project/udisks
Source0:        https://github.com/storaged-project/udisks/releases/download/udisks-%{version}/udisks-%{version}.tar.bz2

BuildRequires:  automake
BuildRequires:  autoconf
BuildRequires:  glib2-devel
BuildRequires:  gobject-introspection-devel
BuildRequires:  libgudev1-devel
BuildRequires:  libatasmart-devel
BuildRequires:  polkit-devel
BuildRequires:  systemd
BuildRequires:  systemd-devel
BuildRequires:  libacl-devel
BuildRequires:  chrpath
BuildRequires:  gtk-doc
BuildRequires:  gettext-devel
BuildRequires:  libblockdev-devel
BuildRequires:  libblockdev-part-devel
BuildRequires:  libblockdev-loop-devel
BuildRequires:  libblockdev-swap-devel
BuildRequires:  libblockdev-mdraid-devel
BuildRequires:  libblockdev-fs-devel
BuildRequires:  libblockdev-crypto-devel
BuildRequires:  libmount-devel
BuildRequires:  libuuid-devel

Requires:       libblockdev
Requires:       libblockdev-part
Requires:       libblockdev-loop
Requires:       libblockdev-swap
Requires:       libblockdev-mdraid
Requires:       libblockdev-fs
Requires:       libblockdev-crypto
Requires:       dbus
Requires:       udev
Requires:       libatasmart
Requires:       util-linux
Requires:       e2fsprogs
Requires:       xfsprogs
Requires:       ntfsprogs
Requires:       dosfstools
Requires:       gdisk
Requires:       eject
Requires:       libmount

Requires:       lib%{name}%{?_isa} = %{version}-%{release}

Provides:       storaged = %{version}-%{release}
Obsoletes:      storaged

%description
The UDisks project provides a daemon, tools and libraries to access and
manipulate disks, storage devices and technologies.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package -n lib%{name}
Summary: Dynamic library to access the udisksd daemon
License: LGPLv2+
Provides: libstoraged = %{version}-%{release}
Obsoletes: libstoraged

%description -n lib%{name}
This package contains the dynamic library, which provides access to the
udisksd daemon.

%package -n lib%{name}-devel
Summary: Development files for lib%{name}
License: LGPLv2+
Requires: lib%{name} = %{version}-%{release}
Provides: libstoraged-devel = %{version}-%{release}
Obsoletes: libstoraged-devel

%description -n lib%{name}-devel
This package contains the development files for the library lib%{name}, a
dynamic library, which provides access to the udisksd daemon.

%package iscsi
Summary: Module for iSCSI
License: LGPLv2+
Requires: %{name} = %{version}-%{release}
Requires: iscsi-initiator-utils
BuildRequires: iscsi-initiator-utils-devel
Provides: storaged-iscsi = %{version}-%{release}
Obsoletes: storaged-iscsi

%description iscsi
This package contains module for iSCSI configuration.

%package lvm2
Summary: Module for LVM2
License: LGPLv2+
Requires: %{name} = %{version}-%{release}
Requires: lvm2
BuildRequires: lvm2-devel
BuildRequires: libblockdev-lvm-devel
Provides: storaged-lvm2 = %{version}-%{release}
Obsoletes: storaged-lvm2 

%description lvm2
This package contains module for LVM2 configuration.

%package lsm
Summary: Module for LSM
License: LGPLv2+
Requires: %{name} = %{version}-%{release}
Requires: libstoragemgmt
BuildRequires: libstoragemgmt-devel
BuildRequires: libconfig-devel
Provides: storaged-lsm = %{version}-%{release}
Obsoletes: storaged-lsm

%description lsm
This package contains module for LSM configuration.

%prep
%setup -q -n udisks-%{version}

sed -i udisks/udisks2.conf.in -e "s/encryption=luks1/encryption=luks2/"

%build
autoreconf -ivf
%configure \
        --enable-gtk-doc \
        --enable-lsm \
        --enable-lvm2 \
        --enable-iscsi
%{make_build}

%install
%{make_install}

find %{buildroot} \( -name '*.la' -o -name '*.a' \) -delete -print

chrpath --delete %{buildroot}/%{_sbindir}/umount.udisks2
chrpath --delete %{buildroot}/%{_bindir}/udisksctl
chrpath --delete %{buildroot}/%{_libexecdir}/udisks2/udisksd

%find_lang udisks2

%post
%systemd_post udisks2.service
# only trigger when udev is accessible
if [ -S /run/udev/control ]; then
    udevadm control --reload
    udevadm trigger
fi

%preun
%systemd_preun udisks2.service

%postun
%systemd_postun_with_restart udisks2.service

%files -f %{name}.lang
%doc HACKING
%license COPYING
%{_sysconfdir}/udisks2/udisks2.conf
%{_sysconfdir}/udisks2/mount_options.conf.example
%{_datadir}/dbus-1/system.d/org.freedesktop.UDisks2.conf
%{_datadir}/bash-completion/completions/udisksctl
%{_tmpfilesdir}/%{name}.conf
%{_unitdir}/udisks2.service
%{_udevrulesdir}/80-udisks2.rules
%{_sbindir}/umount.udisks2
%{_bindir}/udisksctl

%dir %{_sysconfdir}/udisks2/modules.conf.d
%dir %{_libdir}/udisks2/modules
%{_libexecdir}/udisks2/udisksd
%{_mandir}/man1/*
%{_mandir}/man5/udisks2.conf.5*
%{_mandir}/man8/*

%{_datadir}/polkit-1/actions/org.freedesktop.UDisks2.policy
%{_datadir}/dbus-1/system-services/org.freedesktop.UDisks2.service
%attr(0700,root,root) %dir %{_localstatedir}/lib/udisks2

%files doc
%doc README.md AUTHORS NEWS

%files -n lib%{name}
%{_libdir}/libudisks2.so.0
%{_libdir}/libudisks2.so.0.*
%{_libdir}/girepository-1.0/UDisks-2.0.typelib

%files -n lib%{name}-devel
%{_libdir}/libudisks2.so
%{_includedir}/udisks2/udisks/*.h
%{_datadir}/gir-1.0/UDisks-2.0.gir
%{_datadir}/gtk-doc/html/udisks2/*
%{_libdir}/pkgconfig/udisks2*.pc

%files -n %{name}-iscsi
%{_libdir}/udisks2/modules/libudisks2_iscsi.so
%{_datadir}/polkit-1/actions/org.freedesktop.UDisks2.iscsi.policy

%files -n %{name}-lvm2
%{_libdir}/udisks2/modules/libudisks2_lvm2.so
%{_datadir}/polkit-1/actions/org.freedesktop.UDisks2.lvm2.policy

%files -n %{name}-lsm
%{_libdir}/udisks2/modules/libudisks2_lsm.so
%{_mandir}/man5/udisks2_lsm.conf.*
%{_datadir}/polkit-1/actions/org.freedesktop.UDisks2.lsm.policy
%attr(0600,root,root) %{_sysconfdir}/udisks2/modules.conf.d/udisks2_lsm.conf

%changelog
* Thu Sep 30 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.9.4-3
- add doc package

* Thu Mar 17 2022 Su Lifan <su-lifan@linux.alibaba.com> - 2.9.4-2
- Fix default LUKS version

* Fri Mar 11 2022 Su Lifan <su-lifan@linux.alibaba.com> - 2.9.4-1
- Initial packaging for Anolis OS 23
